/*
**	LED-LC circuit
*/
#include "x.c"
#define W 500
#define H 500
#define y1 60
#define y2 300
#define y3 (H-36)
#define Vd(i) (0.3*(log((i)+0.001)+1))

int Lpd= 0;
xdp(int a, int b) { XDrawPoint(dpy,w1,gc,a,b); }
xdl(int a, int b, int c, int d) { XDrawLine(dpy,w1,gc,a,b,c,d); }

main(argc,argv)
char **argv;
{
	double vi, vc, vl, il, ic;
	double T= 0.25;	//micro second
	double L= 5;	//micro Henry
	double C= 50;	//micro Farad
	int i,on=0;
	iwt("LED-LC circuit",W,H);
	vi= vc= ic= il= 0;
	for(i= 0; i< W; i++){
		if(i%100==0) {
			xdl(i,y1-5,i,y1+5);
			xdl(i,y2-5,i,y2+5);
			xdl(i,y3-5,i,y3+5);
			on= 1- on;
		}
		if(i%4==0){ xdp(i,y1); xdp(i,y2); xdp(i,y3); }

		if(on) vi= 12;
		else   vi= -Vd(il);
		vl= vi - vc;

		if(Lpd && on==0) vl= -Vd(il);
		il+= vl*T/L; if(il<0)il= 0;
		ic= il;
		if(Lpd) { ic-= exp(-vl/0.3 -1); if(ic<0) ic= 0; }
		vc+= (ic - exp(10*vc - 100))*T/C;
		xdp(i,y1-4*vi); xdp(i,y2-16*vc); xdp(i,y3-3*ic);
	}
	XFlush(dpy);
	printf("period=%6.3f[micro sec]\nPush Return key\n",2*M_PI*sqrt(L*C));
	getchar();
}
